
//---------------------------------------------------------------------------

#include <vcl.h>
#include<ToolsApi.hpp>
#pragma hdrstop

#include "IntfMain.h"
#include "OTAUtils.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmExpert *frmExpert;
static  char curDir[MAX_PATH];
static AnsiString DefaultExt;
//---------------------------------------------------------------------------
__fastcall TfrmExpert::TfrmExpert(TComponent* Owner)
        : TForm(Owner)
{
   GetCurrentDirectory(MAX_PATH,curDir);
   ProjectDirectory = curDir;//set the project directory to the current directory
   ProjectDirectory = IncludeTrailingBackslash(ProjectDirectory);
   DefaultExt = GeoUtils::GetProductProjectExtension(false);
   lvError->Items->Clear();
   lvError->Visible = false;
   Height = NORMALHEIGHT;
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::spbtnAnnulerClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::spbtnSuivantClick(TObject *Sender)
{
  Height = NORMALHEIGHT;
  lvError->Items->Clear();
  lvError->Visible = false;
  if(CheckPage(pcEtapeExpert->ActivePageIndex))
  {
    //go to next page
    PageSuivante();
    //navigation (buttons) management
    GererBouton();
  }
  else
  {
   Height = ERRORHEIGHT;
   lvError->Visible = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::spbtnTerminerClick(TObject *Sender)
{
  //everthing is Ok. So launch code generation
  try
  {
        GeoUtils::CloseAll();
        TInfoExpertCollector nfoCollector;
        //assign the properties
        nfoCollector.TypeExpert     =  FTypeWizard;
        nfoCollector.Cheminprojet   =  ProjectDirectory;
        nfoCollector.NomProjet      =  edtNomProjet->Text;
        nfoCollector.IOTAWizardNom  =  edtIOTAWizardNom->Text;
        nfoCollector.strFicherIcone =  lblIcoFile->Caption;//uses only to generate a resource script for Form or project Expert.

        AnsiString strfiche = edtNewFicheClass->Text;
        //add the T before
        if(strfiche.Pos("T")==1)
         nfoCollector.NewFicheClass  =  edtNewFicheClass->Text;
        else
          nfoCollector.NewFicheClass  =  "T"+edtNewFicheClass->Text;
          
        nfoCollector.OTAWizardPage  =  edtOTAWizardPage->Text;
        nfoCollector.IOTAWizardComent = edtIOTAWizardComent->Text;
        nfoCollector.IOTAWizardAuthor= edtIOTAWizardAuthor->Text;
        nfoCollector.IOTAWizardMenuText= edtIOTAWizardMenuText->Text;
        nfoCollector.IOTAWizardIdString= edtIOTAWizardIdString->Text;
        nfoCollector.IsDll = rbExpertDll->Checked;
        
        AnsiString strwiz = edtClasseWizardName->Text;
        if(strwiz.Pos("T") == 1)
         nfoCollector.ClasseWizardName= edtClasseWizardName->Text;
        else
         nfoCollector.ClasseWizardName= "T"+edtClasseWizardName->Text;

        //call the object's generation methode
        nfoCollector.MakeExpertCode();

        if(rbExpertDll->Checked)
          GeoUtils::SetOption("UsePackages", true);//une Dll utilise les paquets
        else
          GeoUtils::SetOption("DesigntimeOnly", true);//une Dll utilise les paquets
  }
  catch(const Exception & ex)
  {
    MessageDlg(ex.Message,mtError,TMsgDlgButtons()<<mbOK,0);
  }
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::spbtnPrecedentClick(TObject *Sender)
{
    Height = NORMALHEIGHT;
    lvError->Items->Clear();
    lvError->Visible = false;
    PagePrecedente();
    //navigation (buttons) management
    GererBouton();
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::GererBouton()
{
        //A FAIRE : Ajoutez votre code ici
        spbtnAnnuler->Enabled = true;
        spbtnSuivant->Enabled = (pcEtapeExpert->ActivePageIndex == 0) ||
                                (pcEtapeExpert->ActivePageIndex != pcEtapeExpert->PageCount - 1);

        spbtnTerminer->Enabled = pcEtapeExpert->ActivePageIndex == pcEtapeExpert->PageCount - 1;
        spbtnPrecedent->Enabled = (pcEtapeExpert->ActivePageIndex != 0);
}


void __fastcall TfrmExpert::FormCreate(TObject *Sender)
{
      pnlEnvironnement->Caption = GeoUtils::GetProductIdentifier();
      pcEtapeExpert->ActivePageIndex = 0;
      ClassWizardName = "CustomExpert";
      FTypeWizard = twAide;
      InitPage(pcEtapeExpert->ActivePageIndex);
      GererBouton();
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::PageSuivante()
{
        //A FAIRE : Ajoutez votre code ici
        if(pcEtapeExpert->ActivePageIndex != pcEtapeExpert->PageCount - 1)
        {
          //attention si le type d'expert n'est pas fiche ou Projet il faut passer sur la quatrime page
          if(pcEtapeExpert->ActivePageIndex == PAGECLASSEEXPERT)
          {
            //twFiche, twProjet, twAide, twAddIn
            if((FTypeWizard == twAddIn) || (FTypeWizard == twAide))
            {
               pcEtapeExpert->ActivePageIndex += 2;
               InitPage(pcEtapeExpert->ActivePageIndex);
               return;
            }
          }
            pcEtapeExpert->ActivePageIndex += 1;
        }
        InitPage(pcEtapeExpert->ActivePageIndex);
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::PagePrecedente()
{
        //A FAIRE : Ajoutez votre code ici
        if(pcEtapeExpert->ActivePageIndex != 0)
        {

          //attention si le type d'expert n'est pas fiche ou Projet il faut passer sur la quatrime page
          if(pcEtapeExpert->ActivePageIndex == PAGERECAPITULATIF)
          {
            //twFiche, twProjet, twAide, twAddIn
            if((FTypeWizard == twAddIn) || (FTypeWizard == twAide))
            {
               pcEtapeExpert->ActivePageIndex -= 2;
               InitPage(pcEtapeExpert->ActivePageIndex);
               return;
            }
          }
          pcEtapeExpert->ActivePageIndex -= 1;
        }
        InitPage(pcEtapeExpert->ActivePageIndex);
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::rbtExpertmenuClick(TObject *Sender)
{
    FTypeWizard = twAddIn;
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::rbtExpertficheClick(TObject *Sender)
{
   FTypeWizard = twFiche;
   //
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::rbtExpertmenuaideClick(TObject *Sender)
{
  FTypeWizard = twAide;
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::rbtExpertprojetClick(TObject *Sender)
{
  FTypeWizard = twProjet;
}
//---------------------------------------------------------------------------
bool __fastcall TfrmExpert::CheckPage(int pageIndex)
{
        //A FAIRE : Ajoutez votre code ici
        switch(pageIndex)
        {
            case PAGECHOIXEXPERT :
               return CheckPageChoixExpert();
            case PAGECLASSEEXPERT  :
               return CheckPageClasseExpert();
            case PAGEREPOSITORY:
               return CheckPageRepository();
        }
        return true;
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::InitPage(int pageIndex)
{
        //A FAIRE : Ajoutez votre code ici
        switch(pageIndex)
        {
            case PAGECHOIXEXPERT :
               InitPageChoixExpert();
               break;
            case PAGECLASSEEXPERT  :
               InitPageClasseExpert();
               break;
            case PAGERECAPITULATIF :
               Summary();
              break;
            case PAGEREPOSITORY:
               InitPageRepository();
               break;
        }
}
//---------------------------------------------------------------------------
bool __fastcall TfrmExpert::CheckPageRepository()
{
        //A FAIRE : Ajoutez votre code ici
        TTypeError* ptrTypeError = NULL;
        TListItem* newItem = NULL;
       //teError, teWarning, teHint
        if(edtIOTAWizardAuthor->Text.Trim()== "")
        {
          ptrTypeError = new TTypeError();
          ptrTypeError->ErrorMessage = "Le nom de l'auteur est inconnu !";
          ptrTypeError->ErrorType = teError;
          ptrTypeError->ErrorControl = edtIOTAWizardAuthor;
          newItem = lvError->Items->Add();
          newItem->Data = ptrTypeError;
        }
        if(edtIOTAWizardComent->Text.Trim()== "")
        {
          ptrTypeError = new TTypeError();
          ptrTypeError->ErrorMessage = "Vous devez donner un commentaire !";
          ptrTypeError->ErrorType = teError;
          ptrTypeError->ErrorControl = edtIOTAWizardComent;
          newItem = lvError->Items->Add();
          newItem->Data = ptrTypeError;

        }
        if(edtOTAWizardPage->Text.Trim() =="")
        {
          ptrTypeError = new TTypeError();
          ptrTypeError->ErrorMessage = "Vous devez donner le nom de la page o sera installe l'expert !";
          ptrTypeError->ErrorType = teError;
          ptrTypeError->ErrorControl = edtOTAWizardPage;
          newItem = lvError->Items->Add();
          newItem->Data = ptrTypeError;
        }

        if(FTypeWizard == twFiche)
        {
          if(edtNewFicheClass->Text.Trim() == "")
          {
            ptrTypeError = new TTypeError();
            ptrTypeError->ErrorMessage = "Impossible de crer l'expert de fiche sans le nom de la classe !";
            ptrTypeError->ErrorType = teError;
            ptrTypeError->ErrorControl = edtNewFicheClass;
            newItem = lvError->Items->Add();
            newItem->Data = ptrTypeError;
          }
        }
        if(!imglOTAWizardIcone->Picture)
        {
          ptrTypeError = new TTypeError();
          ptrTypeError->ErrorMessage = "Un expert de repository doit avoir une icne !";
          ptrTypeError->ErrorType = teError;
          ptrTypeError->ErrorControl = btnlOTAWizardIcone;
          newItem = lvError->Items->Add();
          newItem->Data = ptrTypeError;
        }
        return (lvError->Items->Count == 0);
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::InitPageRepository()
{
        //A FAIRE : Ajoutez votre code ici
        grpbExpertFiche->Visible  = (FTypeWizard == twFiche);
}

//---------------------------------------------------------------------------
bool __fastcall TfrmExpert::CheckPageChoixExpert()
{
        TTypeError* ptrTypeError = NULL;
        TListItem* newItem = NULL;
        //A FAIRE : Ajoutez votre code ici
        if(edtNomProjet->Text.Trim() == "")
        {
            ptrTypeError = new TTypeError();
            ptrTypeError->ErrorMessage = "Le nom du projet est inconnu !";
            ptrTypeError->ErrorType = teError;
            ptrTypeError->ErrorControl = edtNomProjet;  
            newItem = lvError->Items->Add();
            newItem->Data = ptrTypeError;
            return false;
        }
        return true;  
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::InitPageChoixExpert()
{
        rbtExpertmenu->Checked = false;
        rbtExpertfiche->Checked = false;
        rbtExpertmenuaide->Checked = false;
        rbtExpertprojet->Checked = false;
        grpbExpertFiche->Visible = false;
        //A FAIRE : Ajoutez votre code ici
        switch(FTypeWizard)
        {
            case twAddIn   :
                rbtExpertmenu->Checked = true;
                break;
            case twFiche  :
                rbtExpertfiche->Checked  = true;
                grpbExpertFiche->Visible = true;
                break;
            case twAide   :
                rbtExpertmenuaide->Checked = true;
                break;
            case twProjet :
               rbtExpertprojet->Checked = true;
                break;
        }
}

//---------------------------------------------------------------------------
void __fastcall TfrmExpert::edtClasseWizardNameExit(TObject *Sender)
{
  ClassWizardName = edtClasseWizardName->Text;
}
//---------------------------------------------------------------------------
bool __fastcall TfrmExpert::CheckPageClasseExpert()
{
        TTypeError* ptrTypeError = NULL;
        TListItem* newItem = NULL;
        //A FAIRE : Ajoutez votre code ici
        if( edtClasseWizardName->Text.Trim() == "")
        {
            ptrTypeError = new TTypeError();
            ptrTypeError->ErrorMessage = "Impossible de crer l'expert si le nom de la classe d'implmentation est inconnu !";
            ptrTypeError->ErrorType = teError;
            ptrTypeError->ErrorControl = edtClasseWizardName;
            newItem = lvError->Items->Add();
            newItem->Data = ptrTypeError;
       }
        if(edtIOTAWizardNom->Text.Trim() == "")
        {
            ptrTypeError = new TTypeError();
            ptrTypeError->ErrorMessage = "Valeur requise pour la classe d'implmentation !";
            ptrTypeError->ErrorType = teError;
            ptrTypeError->ErrorControl = edtIOTAWizardNom;
            newItem = lvError->Items->Add();
            newItem->Data = ptrTypeError;

        }
        if(edtIOTAWizardIdString->Text.Trim() =="")
        {
            ptrTypeError = new TTypeError();
            ptrTypeError->ErrorMessage = "Valeur requise pour la classe d'implmentation !";
            ptrTypeError->ErrorType = teError;
            ptrTypeError->ErrorControl = edtIOTAWizardIdString;
            newItem = lvError->Items->Add();
            newItem->Data = ptrTypeError;

        }

        if(edtIOTAWizardMenuText->Text.Trim() == "")
        {
            ptrTypeError = new TTypeError();
            ptrTypeError->ErrorMessage = "Valeur requise pour la classe d'implmentation !";
            ptrTypeError->ErrorType = teError;
            ptrTypeError->ErrorControl = edtIOTAWizardMenuText;
            newItem = lvError->Items->Add();
            newItem->Data = ptrTypeError;
        }
        return (lvError->Items->Count == 0);
}
//---------------------------------------------------------------------------
void __fastcall TfrmExpert::InitPageClasseExpert()
{
        //A FAIRE : Ajoutez votre code ici
        edtClasseWizardName->Text = ClassWizardName;
}

//---------------------------------------------------------------------------
void __fastcall TfrmExpert::SpeedButton1Click(TObject *Sender)
{
   AnsiString Chemin = IncludeTrailingBackslash(GeoSystem::BrowseForFolder(Handle));

   if(Chemin.Trim() != "")
   {
     ProjectDirectory = Chemin;
     SetCurrentDirectory(Chemin.c_str());
     if(edtNomProjet->Text.Trim() !="")
       edtCheminprojet->Text = ProjectDirectory + edtNomProjet->Text + DefaultExt;
   }
}
//---------------------------------------------------------------------------


void __fastcall TfrmExpert::Summary()
{
        //A FAIRE : Ajoutez votre code ici
        //on rassemble toutes les inforamtion et on charge le Memo
        mmSummary->Lines->Clear();

        switch(FTypeWizard)
        {
            case twAddIn   :
                mmSummary->Lines->Add("Cration d'un expert add-in");
                break;
            case twFiche  :
                mmSummary->Lines->Add("Cration d'un expert de fiche");
                mmSummary->Lines->Add("Gnration d'une nouvelle fiche");
                break;
            case twAide   :
                mmSummary->Lines->Add("Cration d'un expert standard (Menu Aide)");
                break;
            case twProjet :
               mmSummary->Lines->Add("Cration d'un expert de projet");
                break;
        }
        mmSummary->Lines->Add("");
        mmSummary->Lines->Add("Nom du projet : ");
        mmSummary->Lines->Add(edtCheminprojet->Text+" "+edtNomProjet->Text);

        mmSummary->Lines->Add("");
        mmSummary->Lines->Add("Classe d'expert : ");
        mmSummary->Lines->Add("T"+edtClasseWizardName->Text.Trim());

}
void __fastcall TfrmExpert::edtNomProjetChange(TObject *Sender)
{
  //when the edit component changes reflects this change in the
  //directiry Edit
  if(edtNomProjet->Text.Trim() != "")
    edtCheminprojet->Text = ProjectDirectory +edtNomProjet->Text+DefaultExt;
  else
    edtCheminprojet->Text = "";
}
//---------------------------------------------------------------------------


void __fastcall TfrmExpert::rbExpertPackageClick(TObject *Sender)
{
//
  DefaultExt =  GeoUtils::GetProductProjectExtension(false);
  AnsiString chemin = edtCheminprojet->Text;
  if(chemin.Trim() != "")
  {
    edtCheminprojet->Text = ProjectDirectory +edtNomProjet->Text+DefaultExt;
  }

}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::rbExpertDllClick(TObject *Sender)
{
  //
  DefaultExt =  GeoUtils::GetProductProjectExtension(true);
  AnsiString chemin = edtCheminprojet->Text;
  if(chemin.Trim() != "")
  {
    edtCheminprojet->Text = ProjectDirectory +edtNomProjet->Text+DefaultExt;
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::edtNomProjetKeyPress(TObject *Sender, char &Key)
{
  // the project name don't need an extension (dpr,bpr....)
  if(Key == '.') Key = 0x0;
}
//---------------------------------------------------------------------------



void __fastcall TfrmExpert::btnlOTAWizardIconeClick(TObject *Sender)
{
//permettre le chois d'une icne
  if(OpdIconeRepository->Execute())
  {
     imglOTAWizardIcone->Picture->Icon->LoadFromFile(OpdIconeRepository->FileName);
     lblIcoFile->Caption = OpdIconeRepository->FileName;
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::lvErrorCustomDrawItem(TCustomListView *Sender,
      TListItem *Item, TCustomDrawState State, bool &DefaultDraw)
{
  TTypeError* ptrTypeError;
  if(Item)
  {
    ptrTypeError = static_cast<TTypeError*>(Item->Data);
    if(ptrTypeError)
    {
      Item->Caption = ptrTypeError->ErrorMessage;
      switch (ptrTypeError->ErrorType)
      {
        case teError:
          lvError->Font->Color = clRed;
          break;
        case teWarning :
          lvError->Font->Color = clNavy;
          break;
        case teHint :
          lvError->Font->Color = clGreen;
          break;
      }
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmExpert::lvErrorDeletion(TObject *Sender,
      TListItem *Item)
{
  TTypeError* ptrTypeError;
  if(Item)
  {
    ptrTypeError = static_cast<TTypeError*>(Item->Data);
    if(ptrTypeError)
    {
     delete ptrTypeError;
    }
   }
}
//---------------------------------------------------------------------------


void __fastcall TfrmExpert::lvErrorDblClick(TObject *Sender)
{
//
  TTypeError* ptrTypeError;
  TListItem* Item = lvError->Selected;
  TWinControl* AControl;
  if(Item)
  {
    ptrTypeError = static_cast<TTypeError*>(Item->Data);
    if(ptrTypeError)
    {
      AControl = ptrTypeError->ErrorControl;
      if(AControl)
      {
        if((AControl->Enabled) && (AControl->Visible))
        {
          AControl->SetFocus();
        }
      }
    }
   }

}
//---------------------------------------------------------------------------

