//---------------------------------------------------------------------------
/*
**Calling IOTAModuleServices.OpenProject on a BPG file will crash the IDE.
  Instead, use IOTAModuleServices.OpenFile.
**When querying IOTAProjectGroup.FileName, you won't get a full pathname.
  Instead query the IOTAModule that implements IOTAProjectGroup for its FileName,
  and it will contain a full path.
*/
#include <vcl.h>
#pragma hdrstop

#include "IntfUtils.h"
#include "delphitemplate.h"
#include "UtilsConf.h"

#pragma package(smart_init)
__fastcall TInfoExpertCollector::TInfoExpertCollector()
{
        FTypeExpert          = twNone;
        FCheminprojet        = "";
        FCheminprojet        = IncludeTrailingBackslash(FCheminprojet);
        FNewFicheClass       = "";
        FOTAWizardPage       = "";
        FIOTAWizardComent    = "";
        FIOTAWizardAuthor    = "";
        FIOTAWizardMenuText  = "";
        FIOTAWizardIdString  = "";
        FIOTAWizardNom       = "";
        FClasseWizardName    = "";
        FNomProjet           = "";
        FIcon                = NULL;
}
__fastcall TInfoExpertCollector::~TInfoExpertCollector()
{

}

void __fastcall TInfoExpertCollector::MakeExpertCode()
{
        CreateProjectGroup();
        switch (FTypeExpert)
        {
          case twFiche :
            GeoSystem::CreateRessourceScript(FCheminprojet+FNomProjet,"ID_"+FIOTAWizardNom,FstrFicherIcone);
            CreateFormWizard();
            break;
          case twProjet:
            GeoSystem::CreateRessourceScript(FCheminprojet+FNomProjet,"ID_"+FIOTAWizardNom,FstrFicherIcone);
            CreateProjectWizard();
            break;
          case twAide:
           CreateHelpWizard();
           break;
          case twAddIn:
           CreateAddInWizard();
           break;
          default: throw EUnknowWizardType("unsupported wizard!!");
        }
}

_di_IOTAProjectGroup __fastcall TInfoExpertCollector::CreateProjectGroup()
{
   AnsiString cheminbpg = FCheminprojet+"GEOGroup.bpg";
   TOTAProjectGroupCreator *groupproject = new TOTAProjectGroupCreator(cheminbpg);
   groupproject->AddRef();
   _di_IOTAProjectGroup newmodule = GeoUtils::CreateSimpleModule(groupproject);
   groupproject->Release();
   return newmodule;
}

void __fastcall TInfoExpertCollector::CreateAddInWizard()
{
  _di_IOTAProjectGroup groupModule = GeoUtils::GetProjectGroup();
  if(groupModule)
  {
    //cration du projet
    AnsiString chaineTpl;
    AnsiString chaineTplExpert =  FillTemplateExpert(TEMPLATEDELPHIEXPERTMENU);

    if(FIsDll)
    {
      chaineTpl = TEMPLATEDELPHIPROJECTDPR;
      chaineTpl =  StringReplace(chaineTpl,
                                 "%CLASSEXPERT%",
                                 FClasseWizardName,
                                 TReplaceFlags()<<rfReplaceAll);
    }
    else
    {
      chaineTpl = TEMPLATEDELPHIPROJECTDPK;
      chaineTpl = StringReplace(chaineTpl,"%PACKAGEFORM%","",TReplaceFlags()<<rfReplaceAll);
    }

    TOTAProjectCreator *projectcreator = new TOTAProjectCreator(groupModule, chaineTpl, FIsDll);

     projectcreator->AddRef();
     projectcreator->Projectpath = FCheminprojet;
     projectcreator->ProjectName = FNomProjet;
     _di_IOTAModule newmodule    = GeoUtils::CreateSimpleModule(projectcreator);

     TOTAModuleCreator* moduleExpert = new TOTAModuleCreator(newmodule,
                                                             chaineTplExpert);
     moduleExpert->AddRef();
     GeoUtils::CreateSimpleModule(moduleExpert);
     if(!FIsDll)
     {
      GeoUtils::SetOption(newmodule, "DesigntimeOnly", true);
      GeoUtils::SetOption(newmodule, "OutputDir", FCheminprojet);
      GeoUtils::SetOption(newmodule, "PkgDllDir", FCheminprojet);
     }
     moduleExpert->Release();
     projectcreator->Release();
  }
}

void __fastcall TInfoExpertCollector::CreateHelpWizard()
{
  _di_IOTAProjectGroup groupModule = GeoUtils::GetProjectGroup();
  if(groupModule)
  {
    //cration du projet
    AnsiString chaineTpl;
    AnsiString chaineTplExpert =  FillTemplateExpert(TEMPLATEDELPHIEXPERTAIDE);
    if(FIsDll)
    {
      chaineTpl = TEMPLATEDELPHIPROJECTDPR;
      chaineTpl =  StringReplace(chaineTpl,
                                 "%CLASSEXPERT%",
                                 FClasseWizardName,
                                 TReplaceFlags()<<rfReplaceAll);
    }
    else
    {
      chaineTpl = TEMPLATEDELPHIPROJECTDPK;
      chaineTpl = StringReplace(chaineTpl,"%PACKAGEFORM%","",TReplaceFlags()<<rfReplaceAll);
    }


    TOTAProjectCreator *projectcreator = new TOTAProjectCreator(groupModule, chaineTpl, FIsDll);

     projectcreator->AddRef();
     projectcreator->Projectpath = FCheminprojet;
     projectcreator->ProjectName = FNomProjet;
     _di_IOTAModule newmodule    = GeoUtils::CreateSimpleModule(projectcreator);

     TOTAModuleCreator* moduleExpert = new TOTAModuleCreator(newmodule,
                                                             chaineTplExpert);
     moduleExpert->AddRef();
     GeoUtils::CreateSimpleModule(moduleExpert);
     if(!FIsDll)
      GeoUtils::SetOption(newmodule, "DesigntimeOnly", true);
     moduleExpert->Release();
     projectcreator->Release();
  }
}
void __fastcall TInfoExpertCollector::CreateProjectWizard()
{
  _di_IOTAProjectGroup groupModule = GeoUtils::GetProjectGroup();
  //cration du projet
  AnsiString chaineTpl;
  AnsiString chaineTplExpert =  FillTemplateExpert(TEMPLATEDELPHIEXPERTPROJET);
  if(FIsDll)
  {
    chaineTpl = TEMPLATEDELPHIPROJECTDPR;
    chaineTpl =  StringReplace(chaineTpl,
                               "%CLASSEXPERT%",
                               FClasseWizardName,
                               TReplaceFlags()<<rfReplaceAll);
  }
  else
  {
    chaineTpl = TEMPLATEDELPHIPROJECTDPK;
    chaineTpl = StringReplace(chaineTpl,"%PACKAGEFORM%","",TReplaceFlags()<<rfReplaceAll);
  }
  TOTAProjectCreator *projectcreator = new TOTAProjectCreator(groupModule, chaineTpl, FIsDll);
   projectcreator->AddRef();
   projectcreator->Projectpath = FCheminprojet;
   projectcreator->ProjectName = FNomProjet;
   _di_IOTAProject newmodule    = GeoUtils::CreateSimpleModule(projectcreator);

   TOTAModuleCreator* moduleExpert = new TOTAModuleCreator(newmodule,
                                                           chaineTplExpert);
   GeoUtils::CreateSimpleModule(moduleExpert);
   //add the resource script file
   newmodule->AddFile(FCheminprojet+FNomProjet+"rc.rc",true);
     if(!FIsDll)
     {
      GeoUtils::SetOption(newmodule, "DesigntimeOnly", true);
      GeoUtils::SetOption(newmodule, "OutputDir", FCheminprojet);
      GeoUtils::SetOption(newmodule, "PkgDllDir", FCheminprojet);
     }
   projectcreator->Release();
}

void __fastcall TInfoExpertCollector::CreateFormWizard()
{
  _di_IOTAProjectGroup groupModule = GeoUtils::GetProjectGroup();
  //cration du projet
  AnsiString chaineTpl;
  AnsiString chaineTplExpert =  FillTemplateExpert(TEMPLATEDELPHIEXPERTFICHE);
  if(FIsDll)
  {
    chaineTpl = TEMPLATEDELPHIPROJECTDPR;
    chaineTpl =  StringReplace(chaineTpl,
                               "%CLASSEXPERT%",
                               FClasseWizardName,
                               TReplaceFlags()<<rfReplaceAll);
  }
  else
  {
    chaineTpl = TEMPLATEDELPHIPROJECTDPK;
    chaineTpl = StringReplace(chaineTpl,"%PACKAGEFORM%","",TReplaceFlags()<<rfReplaceAll);
  }
  TOTAProjectCreator *projectcreator = new TOTAProjectCreator(groupModule, chaineTpl, FIsDll);
   projectcreator->AddRef();
   projectcreator->Projectpath = FCheminprojet;
   projectcreator->ProjectName = FNomProjet;
   _di_IOTAProject newmodule    = GeoUtils::CreateSimpleModule(projectcreator);

   TOTAModuleCreator* moduleExpert = new TOTAModuleCreator(newmodule,
                                                           chaineTplExpert);
   GeoUtils::CreateSimpleModule(moduleExpert);
   //add the resource script file
   newmodule->AddFile(FCheminprojet+FNomProjet+"rc.rc",true);
     if(!FIsDll)
     {
      GeoUtils::SetOption(newmodule, "DesigntimeOnly", true);
      GeoUtils::SetOption(newmodule, "OutputDir", FCheminprojet);
      GeoUtils::SetOption(newmodule, "PkgDllDir", FCheminprojet);
     }
   projectcreator->Release();
}


AnsiString __fastcall TInfoExpertCollector::FillTemplateExpert(const AnsiString tpl)
{
    AnsiString TemplateExpert = tpl;
    TemplateExpert = StringReplace(TemplateExpert,
                                        "{%}CLASSEXPERT{%}",
                                        FClasseWizardName,
                                        TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                        "%CLASSEXPERT%",
                                        FClasseWizardName,
                                        TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                   "{%}GETAUTHOR{%}",
                                   FIOTAWizardAuthor,
                                   TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                   "%GETAUTHOR%",
                                   FIOTAWizardAuthor,
                                   TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                   "{%}GETCOMMENT{%}",
                                   FIOTAWizardComent,
                                   TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                   "%GETCOMMENT%",
                                   FIOTAWizardComent,
                                   TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                   "{%}GETIDSTRING{%}",
                                   FIOTAWizardIdString,
                                   TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                   "%GETIDSTRING%",
                                   FIOTAWizardIdString,
                                   TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                   "{%}GETNAME{%}",
                                   FNewFicheClass,
                                   TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                   "%GETNAME%",
                                   FNewFicheClass,
                                   TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                   "{%}GETPAGE{%}",
                                   FOTAWizardPage,
                                   TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                   "%GETPAGE%",
                                   FOTAWizardPage,
                                   TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                   "{%}ICON{%}",
                                   "ID_"+FIOTAWizardNom.UpperCase(),
                                   TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                   "%ICON%",
                                   "ID_"+FIOTAWizardNom.UpperCase(),
                                   TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                   "{%}CLASSEFICHE{%}",
                                   FNewFicheClass,
                                   TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                   "%CLASSEFICHE%",
                                   FNewFicheClass,
                                   TReplaceFlags()<<rfReplaceAll);

    TemplateExpert = StringReplace(TemplateExpert,
                                        "{%}FICHIERINC{%}",
                                        FNomProjet+".inc",
                                        TReplaceFlags()<<rfReplaceAll);
    TemplateExpert = StringReplace(TemplateExpert,
                                        "%FICHIERINC%",
                                        FNomProjet+".inc",
                                        TReplaceFlags()<<rfReplaceAll);

    return TemplateExpert;
}



