//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "OTAUtils.h"

#pragma package(smart_init)


namespace GeoUtils
{

void __fastcall CloseAll()
{
        GetModuleServices()->CloseAll(); 
}

void __fastcall EditOption()
{
 try
 {
   _di_IOTAProject projet = GetActiveProject();
   _di_IOTAOptions options;
   if(projet)
   {
     options = projet->GetProjectOptions();
     if(options)
     {
       options->EditOptions();
     }
   }
 }
 catch(const Exception &e)
 {
   ShowMessage(e.Message);
 }
}

void __fastcall SetOption(_di_IOTAProject ActiveProject,AnsiString AnOption, const Variant &Value )
{
   _di_IOTAOptions options = NULL;
   if(ActiveProject)
   {
     options = ActiveProject->GetProjectOptions();
     if(options)
     {
       options->SetOptionValue(AnOption, Value);
     }
   }
}

void __fastcall SetOption(AnsiString AnOption, const Variant &Value )
{
 try
 {
   _di_IOTAProject projet = GetActiveProject();
   _di_IOTAOptions options = NULL;
   if(projet)
   {
     options = projet->GetProjectOptions();
     if(options)
     {
       options->SetOptionValue(AnOption, Value);
     }
   }
 }
 catch(const Exception &e)
 {
   ShowMessage(e.Message);
 }
}

void __fastcall CreateNewUnit(const AnsiString prefix,
                              AnsiString& UnitIdent,
                              AnsiString& ClassName,
                              AnsiString& FileName)
{
  _di_IOTAModuleServices ModuleServices;
  BorlandIDEServices->QueryInterface(__uuidof(IOTAModuleServices),(void**)&ModuleServices);
  if(ModuleServices)
  {
      ModuleServices->GetNewModuleAndClassName(prefix, UnitIdent, ClassName, FileName);
  }
}                              

_di_IOTAModule CreateSimpleModule(_di_IOTACreator ModCreator)
{
  _di_IOTAModuleServices ModuleServices;
  BorlandIDEServices->QueryInterface(__uuidof(IOTAModuleServices),(void**)&ModuleServices);
  if(ModuleServices)
  {
      return ModuleServices->CreateModule(ModCreator);
  }
  return NULL;
}

_di_IOTAActionServices __fastcall GetActionServices()
{
         _di_IOTAActionServices actionservices;
         BorlandIDEServices->QueryInterface(__uuidof(IOTAActionServices),(void**)&actionservices);
         return actionservices;
}

_di_IOTADebuggerServices __fastcall GetDebuggerServices()
{
         _di_IOTADebuggerServices debuggerservices;
         BorlandIDEServices->QueryInterface(__uuidof(IOTADebuggerServices),(void**)&debuggerservices);
         return debuggerservices;
}

_di_IOTAMessageServices __fastcall GetMessageServices()
{
         _di_IOTAMessageServices messageservices;
         BorlandIDEServices->QueryInterface(__uuidof(IOTAMessageServices),(void**)&messageservices);
         return messageservices;
}
_di_IOTAModuleServices __fastcall GetModuleServices()
{
         _di_IOTAModuleServices moduleservices;
         BorlandIDEServices->QueryInterface(__uuidof(IOTAModuleServices),(void**)&moduleservices);
         return moduleservices;
}
_di_IOTAPackageServices __fastcall GetPackageServices()
{
         _di_IOTAPackageServices packageservices;
         BorlandIDEServices->QueryInterface(__uuidof(IOTAPackageServices),(void**)&packageservices);
         return packageservices;
}
_di_INTAServices __fastcall GetNTAServices()
{
         _di_INTAServices ntaservices;
         BorlandIDEServices->QueryInterface(__uuidof(INTAServices),(void**)&ntaservices);
         return ntaservices;
}
_di_IOTAServices __fastcall GetOTAServices()
{
         _di_IOTAServices otaservices;
         BorlandIDEServices->QueryInterface(__uuidof(IOTAServices),(void**)&otaservices);
         return otaservices;
}
_di_IOTAWizardServices __fastcall GetWizardServices()
{
         _di_IOTAWizardServices wizardservices;
         BorlandIDEServices->QueryInterface(__uuidof(IOTAWizardServices),(void**)&wizardservices);
         return wizardservices;
}
_di_IOTAModule __fastcall GetCurrentModule()
{
        _di_IOTAModule CurrentModule = GetModuleServices()->CurrentModule();
         if (!CurrentModule)
         throw Exception("No CurrentModule!!");
         return CurrentModule; 
}
int __fastcall GetModuleCount(void)
{
        return GetModuleServices()->GetModuleCount();
}
_di_IOTAModule __fastcall GetModule(const int Index)
{
        if(Index > -1)
          return GetModuleServices()->GetModule(Index);
        return NULL;
}
AnsiString __fastcall GetBaseRegistryKey()
{
        return GetOTAServices()->GetBaseRegistryKey();
}
AnsiString __fastcall GetProductIdentifier()
{
        return GetOTAServices()->GetProductIdentifier();
}

AnsiString __fastcall GetProductProjectExtension(bool isDll)
{
  AnsiString produit = GetProductIdentifier();
  if(produit == _DELPHIIDENTIFIER)
  {
    if(isDll) return ".dpr";
    else return ".dpk";
  }

  if(produit == _CBUILDERIDENTIFIER)
  {
    if(isDll) return ".bpr";
    else return ".bpk";
  }
  return ""; 
}

_di_IOTAEnvironmentOptions __fastcall GetEnvironmentOptions()
{
        return GetOTAServices()->GetEnvironmentOptions();
}
int __fastcall AddNotifier(const _di_IOTAIDENotifier Notifier)
{
        if(Notifier)
          return GetOTAServices()->AddNotifier(Notifier);
        return -1;
}
void __fastcall RemoveIDENotifier(const int Index)
{
        if(Index > -1)
          GetOTAServices()->RemoveNotifier(Index);
}
TMainMenu* __fastcall GetMainMenu(void)
{
        return GetNTAServices()->GetMainMenu();
}
TToolBar* __fastcall GetToolBar(const AnsiString ToolBarName)
{
        return GetNTAServices()->GetToolBar(ToolBarName);
}
TCustomImageList* __fastcall GetImageList(void)
{
        return GetNTAServices()->GetImageList();
}
TCustomActionList* __fastcall GetActionList(void)
{
        return GetNTAServices()->GetActionList();
}
int __fastcall AddMasked(Graphics::TBitmap* Image, Graphics::TColor MaskColor)
{
        return GetNTAServices()->AddMasked(Image, MaskColor,"");
}
AnsiString __fastcall GetFileName()
{
        return GetCurrentModule()->GetFileName();
}
AnsiString __fastcall GetFileSystem()
{
       AnsiString filesystem;
        filesystem = GetCurrentModule()->GetFileSystem();
        if (filesystem.Trim() == "")
          throw Exception("No FileSystem available");
        return filesystem;

}
_di_IOTAProject __fastcall GetOwner(const int Index)
{
        return GetCurrentModule()->GetOwner(Index);
}
int __fastcall GetOwnerCount(void)
{
        return GetCurrentModule()->GetOwnerCount();
}
void __fastcall SetFileName(const AnsiString FileName)
{
        if(FileName.Trim() != "")
          GetCurrentModule()->SetFileName(FileName);
}
void __fastcall SetFileSystem(const AnsiString FileSystem)
{
        if(FileSystem.Trim() != "")
         GetCurrentModule()->SetFileSystem(FileSystem);
}

_di_IOTAProjectGroup __fastcall GetProjectGroup()
{

  _di_IOTAModuleServices IModuleServices = NULL;
  _di_IOTAModule IModule = NULL ;
  _di_IOTAProjectGroup IProjectGroup = NULL;
  int loop ;

  IModuleServices = GetModuleServices();
  for (loop = 0 ; loop < IModuleServices->ModuleCount;loop++)
  {
    IModule = IModuleServices->Modules[loop];
    if (IModule->QueryInterface(__uuidof(IOTAProjectGroup), (void**)&IProjectGroup) == S_OK)
     {
       return  IProjectGroup;
    }
  }
  if(!IProjectGroup)
   throw Exception("No project group opened!!");
  return  IProjectGroup;
}

_di_IOTAProject __fastcall GetActiveProject()
{
    _di_IOTAProject project = NULL;
    try
    {
        project = GetProjectGroup()->GetActiveProject();
    }
    catch(const Exception &ex)
    {
      ShowMessage(ex.Message);
    }
    return project;
}

int __fastcall GetProjectCount(void)
{
        return GetProjectGroup()->GetProjectCount();
}
_di_IOTAProject __fastcall GetProject(const int Index)
{
        if(Index > -1) 
          return GetProjectGroup()->GetProject(Index);
        return NULL;  
}
void __fastcall SetActiveProject(const _di_IOTAProject Project)
{
       GetProjectGroup()->SetActiveProject(Project);
}
void __fastcall AddNewProject(void)
{
        return ;
}
void __fastcall AddExistingProject(void)
{
        return ;
}
void __fastcall RemoveProject(const _di_IOTAProject Project)
{
        return ;
}
int __fastcall GetProjectModuleCount(void)
{
        return 0;
}
_di_IOTAModuleInfo __fastcall GetModuleInfo(const int Index)
{
        return 0;
}
_di_IOTAProjectOptions __fastcall GetProjectOptions()
{
        return 0;
}
_di_IOTAProjectBuilder __fastcall GetProjectBuilder()
{
        return 0;
}
bool __fastcall GetShouldBuild(void)
{
        return 0;
}
bool __fastcall BuildProject(TOTACompileMode Mode, bool Wait, bool ClearMessages)
{
        return 0;
}
int __fastcall GetModuleFileCount(void)
{
        return 0;
}
_di_IOTAEditor __fastcall GetModuleFileEditor(const int Index)
{
        return 0;
}
bool __fastcall Close(void)
{
        return 0;
}
bool __fastcall Save(bool ChangeName, bool ForceSave)
{
        return 0;
}
int __fastcall AddNotifier(const _di_IOTAModuleNotifier Notifier)
{
        return 0;
}
void __fastcall RemoveModuleNotifier(const int Index)
{
        return ;
}
_di_IOTAFormEditor __fastcall GetFormEditor()
{
        return 0;
}
AnsiString __fastcall GetFormFileName()
{
        return "";
}
bool __fastcall GetFormModified(void)
{
        return 0;
}
_di_IOTAModule __fastcall GetFormModule()
{
        return 0;
}
_di_IOTAComponent __fastcall GetRootComponent()
{
        return 0;
}
_di_IOTAComponent __fastcall FindComponent(const AnsiString Name)
{
        return 0;
}
_di_INTAFormEditor __fastcall GetNTAFormEditor()
{
        return 0;
}
_di_IFormDesigner __fastcall GetFormDesigner()
{
        return 0;
}
void __fastcall GetNTAFormResource(Classes::TStream* Stream)
{
        return ;
}

TComponent* __fastcall GetTComponent(const _di_IOTAComponent OTAComponent)
{
        return 0;
}
_di_IUnknown __fastcall FindModuleInterface(const GUID &AInterface)
{
        return 0;
}


}//fin du namespace

namespace GeoSystem
{
void __fastcall TextToFile(AnsiString AFileName,AnsiString Text)
{
  try
  {
    Word OpenMode = fmCreate;
    TFileStream* fichierResource =  new TFileStream(AFileName,OpenMode);
    fichierResource->Write(Text.c_str(),Text.Length());
    delete fichierResource;
  }
  catch(...)
  {
    ShowMessage("Impossible de crer le script de ressource"); 
  }
}
void __fastcall CreateRessourceScript(AnsiString AFileName,AnsiString IdName ,AnsiString AIcoFile)
{
  AnsiString strFileName = ExtractFileName(AFileName);
  AnsiString strIdentifiant = FormatDateTime("10ss",Now());
  //load the Icon and save it in a new resource file
  AnsiString restplpas = "const\n\n"+
                         IdName.UpperCase()+"  =  "+strIdentifiant+";";

  AnsiString restpl =  "#ifndef "+ strFileName.UpperCase()+"_RH\n"
                       "#define "+strFileName.UpperCase()+"_RH\n\n"
                       "#define "+IdName.UpperCase()+ "   "+strIdentifiant+"\n\n"
                       "#endif";

  AnsiString restplrc = "#include \""+strFileName+"rh.rh\"\n\n"+
                       IdName.UpperCase()+ "  ICON   \""+AIcoFile+"\"";
  try
  {
    Word OpenMode = fmCreate;
    TFileStream* fichierResource =  new TFileStream(AFileName+"rh.rh",OpenMode);
    fichierResource->Write(restpl.c_str(),restpl.Length());
    delete fichierResource;
    //this is created for include statement in DElPHI
    fichierResource =  new TFileStream(AFileName+".inc",OpenMode);
    fichierResource->Write(restplpas.c_str(),restplpas.Length());
    delete fichierResource;

    fichierResource =  new TFileStream(AFileName+"rc.rc",OpenMode);
    fichierResource->Write(restplrc.c_str(),restplrc.Length());
    delete fichierResource;
  }
  catch(...)
  {
    ShowMessage("Impossible de crer le script de ressource"); 
  }
}
static AnsiString Lastpath;

AnsiString __fastcall BrowseForFolder(HWND AHandleWin)
{
    BROWSEINFO    info;
    char          szDir[MAX_PATH];
    char          szDisplayName[MAX_PATH];
    LPITEMIDLIST  pidl;
    LPMALLOC      pShellMalloc;

    // SHBrowseForFolder reenvoi un PIDL. La mmoire pour le PIDL est alloue
    // par le shell. On devra donc librer cette mmoire donc nois auront besoin
    // d'un pointeur sur l'objet COM du Shell qui va nous servir  librer cette mmoire
    if(SHGetMalloc(&pShellMalloc) == NO_ERROR)
    {
        // si on russit  obtenir un pointeur valide on initialise les champs de
        // la structure BROWSEINFO (voir AIDE API Win32)
        memset(&info, 0x00,sizeof(info));
        info.hwndOwner = AHandleWin;             // fentre parente
        info.pidlRoot  = 0;                      // racine
        info.pszDisplayName = szDisplayName;     // display name
        info.lpszTitle = "Choisir un dossier";   // label caption
        info.ulFlags   = BIF_RETURNONLYFSDIRS;   // config flags
        info.lpfn = 0;

        // on execute le fentre de Browsing
        pidl = SHBrowseForFolder(&info);

        // pidl set  NULL si on appui sur "annuler".
        if(pidl)
        {
            // on converti le PIDL en chane
            if(SHGetPathFromIDList(pidl, szDir))
            {
                // on renvoi la chane
                AnsiString Directory = szDir;
                Lastpath = Directory;
                return IncludeTrailingBackslash(Directory);
            }

            pShellMalloc->Free(pidl);//on libre la mmoire allou par le shell au pidl
        }
        pShellMalloc->Release();//<- un classique
    }
    return "";
}
AnsiString __fastcall GetLastPath()
{
  return IncludeTrailingBackslash(Lastpath);
}


}
