//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtilsConf.h"
#include "OTAUtils.h"
#include "cbuildertemplate.h"
#include "delphitemplate.h"

const AnsiString PROJECTGROUPSOURCE =
"#------------------------------------------------------------------------------\r"
"VERSION = BWS.01\r"
"#------------------------------------------------------------------------------\r"
"!ifndef ROOT\r"
"ROOT = $(MAKEDIR)\\..\r"
"!endif\r"
"#------------------------------------------------------------------------------\r"
"MAKE = $(ROOT)\\bin\\make.exe -$(MAKEFLAGS) -f$**\r"
"DCC = $(ROOT)\\bin\\dcc32.exe $**\r"
"BRCC = $(ROOT)\\bin\\brcc32.exe $**\r"
"#------------------------------------------------------------------------------\r"
"PROJECTS =    \r"
"#------------------------------------------------------------------------------\r"
"default: $(PROJECTS)\r"
"#------------------------------------------------------------------------------\r";
//---------------------------------------------------------------------------
#pragma package(smart_init)
/*************************************************************************************************************/
/*************************************************************************************************************/
/*Implmentation TFileOTA*/
HRESULT STDMETHODCALLTYPE TFileOTA::QueryInterface(REFIID riid, void **ppv)
{
  if (riid==IID_IUnknown || riid==IID_IOTAFile)
  {
    *ppv=this;
    AddRef();
    return S_OK;
  }
  else
   return E_NOINTERFACE;
   
}

ULONG STDMETHODCALLTYPE TFileOTA::AddRef()
{
  return InterlockedIncrement(&ref);
}

ULONG STDMETHODCALLTYPE TFileOTA::Release()
{
  int tmp = InterlockedDecrement(&ref);
  if (tmp==0)
    delete this;
  return tmp;
}

__fastcall TFileOTA ::TFileOTA(AnsiString AFileName)
{
 FFileName = AFileName;
}

__fastcall TFileOTA ::~TFileOTA()
{

}

AnsiString __fastcall TFileOTA ::GetSource()
{
  return FFileName; 
}

System::TDateTime __fastcall TFileOTA ::GetAge()
{
  return -1;
}

/*************************************************************************************************************/
/*************************************************************************************************************/
__fastcall TOTAModuleCreator::TOTAModuleCreator(_di_IOTAProject AOwnerProject)
{
  FOwnerProject = AOwnerProject;
  FModuleOwner = NULL;
  GeoUtils::CreateNewUnit("",FUnitIdent, FClassName, FFileName);
}

__fastcall TOTAModuleCreator::TOTAModuleCreator(_di_IOTAModule AModuleOwner)
{
  FModuleOwner = AModuleOwner;
  FOwnerProject = NULL;
  GeoUtils::CreateNewUnit("",FUnitIdent, FClassName, FFileName);
}

__fastcall TOTAModuleCreator::TOTAModuleCreator(_di_IOTAModule AModuleOwner, AnsiString strTemplate)
{
   FstrTemplateCpp = strTemplate;
   FModuleOwner = AModuleOwner;
   GeoUtils::CreateNewUnit("",FUnitIdent, FClassName, FFileName);
}
__fastcall TOTAModuleCreator::TOTAModuleCreator(_di_IOTAModule AModuleOwner,
                                                AnsiString strTemplateH,
                                                AnsiString strTemplateCpp)
{
   FstrTemplateCpp = strTemplateCpp;
   FstrTemplateH = strTemplateH;
   FModuleOwner = AModuleOwner;
   GeoUtils::CreateNewUnit("",FUnitIdent, FClassName, FFileName);
}

// IUnknown
HRESULT STDMETHODCALLTYPE TOTAModuleCreator::QueryInterface(REFIID riid, void **ppv)
{
        if (riid==IID_IUnknown || riid==IID_IOTACreator || riid==IID_IOTAModuleCreator)
          {
            *ppv=this;
            AddRef();
            return S_OK;}
        else
          return E_NOINTERFACE;
}
ULONG STDMETHODCALLTYPE TOTAModuleCreator::AddRef()
{
        return InterlockedIncrement(&ref);
}
ULONG STDMETHODCALLTYPE TOTAModuleCreator::Release()
{
  int tmp = InterlockedDecrement(&ref);
  if (tmp==0)
    delete this;
  return tmp;
}
// IOTACreator
AnsiString __fastcall TOTAModuleCreator::GetCreatorType()
{
        return sUnit;
}
bool __fastcall TOTAModuleCreator::GetExisting()
{
        return false;
}
AnsiString __fastcall TOTAModuleCreator::GetFileSystem()
{
        return "";
}
_di_IOTAModule __fastcall TOTAModuleCreator::GetOwner()
{
        return FModuleOwner;
}
bool __fastcall TOTAModuleCreator::GetUnnamed()
{
        return true;
}
// IOTAModuleCreator
AnsiString __fastcall TOTAModuleCreator::GetAncestorName()
{
        return "";
}
AnsiString __fastcall TOTAModuleCreator::GetImplFileName()
{
     return GeoSystem::GetLastPath()+ExtractFileName(FFileName);
}
AnsiString __fastcall TOTAModuleCreator::GetIntfFileName()
{
        return
          ChangeFileExt(GeoSystem::GetLastPath()+ExtractFileName(FFileName),".h");
}
AnsiString __fastcall TOTAModuleCreator::GetFormName()
{
        return "";
}
bool __fastcall TOTAModuleCreator::GetMainForm()
{
        return false;
}
bool __fastcall TOTAModuleCreator::GetShowForm()
{
        return false;
}
bool __fastcall TOTAModuleCreator::GetShowSource()
{
        return true;
}
_di_IOTAFile __fastcall TOTAModuleCreator::NewFormFile(const AnsiString FormIdent,const AnsiString AncestorIdent)
{
  // we dont' create a form file (DFM) so return NULL
  return NULL;
}
_di_IOTAFile __fastcall TOTAModuleCreator::NewImplSource(const AnsiString ModuleIdent, const AnsiString FormIdent, const AnsiString AncestorIdent)
{
    AnsiString strTypeImpl = FstrTemplateCpp;
    strTypeImpl = StringReplace(strTypeImpl,"%UNITE%",FUnitIdent,TReplaceFlags()<<rfReplaceAll);
    TFileOTA *f=new TFileOTA(strTypeImpl);
    f->AddRef();
    _di_IOTAFile res=f;
    f->Release();
    return res;
}
_di_IOTAFile __fastcall TOTAModuleCreator::NewIntfSource(const AnsiString ModuleIdent, const AnsiString FormIdent, const AnsiString AncestorIdent)
{
  //Delphi has no interface module (header or h file) so we return NULL.
  if(GeoUtils::GetProductIdentifier() == GeoUtils::_DELPHIIDENTIFIER )
     return NULL;
  //the IDE is C++ BUILDER. We create an OTAFile Filled with the Header Template.
    AnsiString strTypeImpl = FstrTemplateH;
    strTypeImpl = StringReplace(strTypeImpl,"%UNITE%",FUnitIdent,TReplaceFlags()<<rfReplaceAll);
    TFileOTA *f=new TFileOTA(strTypeImpl);
    f->AddRef();
    _di_IOTAFile res=f;
    f->Release();
    return res;
}
void __fastcall TOTAModuleCreator::FormCreated(const _di_IOTAFormEditor FormEditor)
{
 //nothing particular is done here. left empty
}
/******************************************************************************************************************/
/******************************************************************************************************************/
__fastcall TOTAProjectCreator ::TOTAProjectCreator(_di_IOTAProjectGroup  AProjectGroup
                                                   ,AnsiString AProjectSource
                                                   ,bool IsDll)
{
  FProjectGroup  = AProjectGroup;
  FIsDll         = IsDll;
  FProjectSource = AProjectSource;
  FProjectpath   = "";
  FProjectName   = "";
}
// IUnknown
HRESULT STDMETHODCALLTYPE TOTAProjectCreator ::QueryInterface(REFIID riid, void **ppv)
{
        if (riid==IID_IUnknown || riid==IID_IOTACreator || riid==IID_IOTAProjectCreator)
        {
                *ppv=this;
                AddRef();
                return S_OK;
         }
         else
                return E_NOINTERFACE;
}
ULONG STDMETHODCALLTYPE TOTAProjectCreator ::AddRef()
{
        return InterlockedIncrement(&ref);
}
ULONG STDMETHODCALLTYPE TOTAProjectCreator ::Release()
{
  int tmp = InterlockedDecrement(&ref);
  if (tmp==0)
    delete this;
  return tmp;
}
// IOTACreator
AnsiString __fastcall TOTAProjectCreator ::GetCreatorType()
{
    //Is it a Dll Expert?
        if(FIsDll)
          return sLibrary;

   //default type for the expert
        return sPackage;
}
bool __fastcall TOTAProjectCreator ::GetExisting()
{
        return false;
}
AnsiString __fastcall TOTAProjectCreator ::GetFileSystem()
{
        return "";
}
_di_IOTAModule __fastcall TOTAProjectCreator ::GetOwner()
{
  //we return the active project group
  return FProjectGroup;
}
bool __fastcall TOTAProjectCreator ::GetUnnamed()
{
        return true;
}
// IOTAProjectCreator
AnsiString __fastcall TOTAProjectCreator ::GetFileName()
{
    if(GeoUtils::GetProductIdentifier() == GeoUtils::_DELPHIIDENTIFIER )
    {
      if(FIsDll)
        return IncludeTrailingBackslash(FProjectpath)+FProjectName+".dpr";
      else
        return IncludeTrailingBackslash(FProjectpath)+FProjectName+".dpk";
    }

      if(FIsDll)
        return IncludeTrailingBackslash(FProjectpath)+FProjectName+".bpr";
      else
        return IncludeTrailingBackslash(FProjectpath)+FProjectName+".bpk";

}
AnsiString __fastcall TOTAProjectCreator ::GetOptionFileName()
{
    if(GeoUtils::GetProductIdentifier() == GeoUtils::_DELPHIIDENTIFIER )
    {
        return IncludeTrailingBackslash(FProjectpath)+FProjectName+".dof";
    }
    return "";
}
bool __fastcall TOTAProjectCreator ::GetShowSource()
{
        return true;
}
void __fastcall TOTAProjectCreator ::NewDefaultModule()
{
//

}
_di_IOTAFile __fastcall TOTAProjectCreator ::NewOptionSource(const AnsiString ProjectName)
{
        return NULL;
}
void __fastcall TOTAProjectCreator ::NewProjectResource(const _di_IOTAProject)
{
//
}
_di_IOTAFile __fastcall TOTAProjectCreator ::NewProjectSource(const AnsiString ProjectName)
{
    FProjectSource =StringReplace(FProjectSource,"{%}NOMPROJET{%}",FProjectName,TReplaceFlags()<<rfReplaceAll );
    TFileOTA *f = new TFileOTA(FProjectSource);
    f->AddRef();
    _di_IOTAFile res=f;
    f->Release();
    return res;
}
/**************************************************************************************************************/
/**************************************************************************************************************/

__fastcall TOTAProjectGroupCreator::TOTAProjectGroupCreator(const AnsiString AgroupFileName)
{
        FGroupFileName = AgroupFileName;
}
    // IUnknown
HRESULT STDMETHODCALLTYPE TOTAProjectGroupCreator::QueryInterface(REFIID riid, void **ppv)
{
        if (riid==IID_IUnknown || riid==IID_IOTACreator || riid==IID_IOTAProjectGroupCreator)
        {
                *ppv=this;
                AddRef();
                return S_OK;
         }
         else
                return E_NOINTERFACE;
}
ULONG STDMETHODCALLTYPE TOTAProjectGroupCreator::AddRef()
{
        return InterlockedIncrement(&ref);
}
ULONG STDMETHODCALLTYPE TOTAProjectGroupCreator::Release()
{
  int tmp = InterlockedDecrement(&ref);
  if (tmp==0)
    delete this;
  return tmp;
}
// IOTACreator
AnsiString __fastcall TOTAProjectGroupCreator::GetCreatorType()
{
        return "";
}
bool __fastcall TOTAProjectGroupCreator::GetExisting()
{
        return false;
}
AnsiString __fastcall TOTAProjectGroupCreator::GetFileSystem()
{
        return "";
}
_di_IOTAModule __fastcall TOTAProjectGroupCreator::GetOwner()
{
        return NULL;
}
bool __fastcall TOTAProjectGroupCreator::GetUnnamed()
{
        return true;
}
//IOTAProjectGroupCreator
AnsiString  __fastcall TOTAProjectGroupCreator::GetFileName()
{
        return FGroupFileName;
}

bool __fastcall TOTAProjectGroupCreator::GetShowSource()
{
        return false;
}
_di_IOTAFile __fastcall TOTAProjectGroupCreator::NewProjectGroupSource(const AnsiString ProjectGroupName)
{
    TFileOTA *f = new TFileOTA(PROJECTGROUPSOURCE);
    f->AddRef();
    _di_IOTAFile res = f;
    f->Release();
    return res;
}
