//---------------------------------------------------------------------------

#ifndef UtilsConfH
#define UtilsConfH
#include<ToolsApi.hpp> 
/*
  CONFERENCE BORLAND 2001 (8 & 9 Octobre)
  classes utilitaires de cration d'expert
   Jeanphi & JeanPierre 
*/

//---------------------------------------------------------------------------
class TFileOTA :public IOTAFile
{
  private :
    AnsiString FFileName;
    long ref;
  public:
    /*Interface Iunknown*/
    HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv);
    ULONG STDMETHODCALLTYPE AddRef();
    ULONG STDMETHODCALLTYPE Release();
    /*Interface IOTAFile*/
    virtual AnsiString __fastcall GetSource();
    virtual System::TDateTime __fastcall GetAge();

     __fastcall TFileOTA(AnsiString AFileName);
     virtual __fastcall ~TFileOTA();
};
/*************************************************************************************************************/
class TOTAModuleCreator : public IOTAModuleCreator
{
private :
    long ref;
    _di_IOTAProject FOwnerProject;
    _di_IOTAModule FModuleOwner;
    AnsiString FFileName;
    AnsiString FUnitIdent;
    AnsiString FClassName;
    AnsiString FstrTemplateCpp;
    AnsiString FstrTemplateH;
public:
  __fastcall TOTAModuleCreator(_di_IOTAProject AOwnerProject);
  __fastcall TOTAModuleCreator(_di_IOTAModule AModuleOwner);
  __fastcall TOTAModuleCreator(_di_IOTAModule AModuleOwner, AnsiString strTemplate);
  __fastcall TOTAModuleCreator(_di_IOTAModule AModuleOwner, AnsiString strTemplateH,AnsiString strTemplateCpp);
  // IUnknown
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv);
  ULONG STDMETHODCALLTYPE AddRef();
  ULONG STDMETHODCALLTYPE Release();
  // IOTACreator
  AnsiString __fastcall GetCreatorType();
  bool __fastcall GetExisting();
  AnsiString __fastcall GetFileSystem();
  _di_IOTAModule __fastcall GetOwner();
  bool __fastcall GetUnnamed();
  // IOTAModuleCreator
  AnsiString __fastcall GetAncestorName();//Return the Ancestor form name
  /*
      { Return the implementation filename, or blank to have the IDE create a new
      unique one. (C++ .cpp file or Delphi unit) }
  */
  AnsiString __fastcall GetImplFileName();
  /*
    { Return the interface filename, or blank to have the IDE create a new
      unique one.  (C++ header) }
  */
  AnsiString __fastcall GetIntfFileName();
  /*
     Return the form name for GEO it always returns an empty string as we do not create a form  
  */
  AnsiString __fastcall GetFormName();
  
  bool __fastcall GetMainForm();//Return True to Make this module the main form of the given Owner/Project GEO returns false
  bool __fastcall GetShowForm();//GEO return false.
  bool __fastcall GetShowSource();//
  _di_IOTAFile __fastcall NewFormFile(const AnsiString FormIdent,const AnsiString AncestorIdent);
  _di_IOTAFile __fastcall NewImplSource(const AnsiString ModuleIdent, const AnsiString FormIdent, const AnsiString AncestorIdent);
  _di_IOTAFile __fastcall NewIntfSource(const AnsiString ModuleIdent, const AnsiString FormIdent, const AnsiString AncestorIdent);
  void __fastcall FormCreated(const _di_IOTAFormEditor FormEditor);
};
/******************************************************************************************************************/
/******************************************************************************************************************/
class TOTAProjectCreator : public IOTAProjectCreator
{
private :
    long ref;
    bool FIsDll;
    _di_IOTAProjectGroup  FProjectGroup;
    AnsiString FProjectSource;
    AnsiString FProjectpath;
    AnsiString FProjectName;
public:
  __fastcall TOTAProjectCreator(_di_IOTAProjectGroup  AProjectGroup,AnsiString AProjectSource, bool IsDll = false);
  // IUnknown
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv);
  ULONG STDMETHODCALLTYPE AddRef();
  ULONG STDMETHODCALLTYPE Release();
  // IOTACreator
  AnsiString __fastcall GetCreatorType();
  bool __fastcall GetExisting();
  AnsiString __fastcall GetFileSystem();
  _di_IOTAModule __fastcall GetOwner();
  bool __fastcall GetUnnamed();
  // IOTAProjectCreator

  AnsiString __fastcall GetFileName() ; // Return the project filename
  AnsiString __fastcall GetOptionFileName();//Return the option file name (C++ .bpr, .bpk, etc...)
  bool __fastcall GetShowSource();//Return True to show the source
  void __fastcall NewDefaultModule();//Called to create a new default module for this project
  _di_IOTAFile __fastcall NewOptionSource(const AnsiString ProjectName);//Create and return the project option source. (C++)
  void __fastcall NewProjectResource(const _di_IOTAProject);//Called to indicate when to create/modify the project resource file
  _di_IOTAFile __fastcall NewProjectSource(const AnsiString ProjectName);//Create and return the Project source file
  __property   AnsiString Projectpath = {read = FProjectpath, write = FProjectpath};
  __property   AnsiString ProjectName = {read = FProjectName, write = FProjectName};

};

class TOTAProjectGroupCreator : public IOTAProjectGroupCreator
{
    AnsiString FGroupFileName;
    AnsiString FTemplate;
    AnsiString FNomProjet;
    long ref; 
    public :
    // IUnknown
    HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv);
    ULONG STDMETHODCALLTYPE AddRef();
    ULONG STDMETHODCALLTYPE Release();

    // IOTACreator
    AnsiString __fastcall GetCreatorType();
    bool __fastcall GetExisting();
    AnsiString __fastcall GetFileSystem();
    _di_IOTAModule __fastcall GetOwner();
    bool __fastcall GetUnnamed();

    //IOTAProjectGroupCreator
    AnsiString  __fastcall GetFileName();
    bool __fastcall GetShowSource();
    _di_IOTAFile __fastcall NewProjectGroupSource(const AnsiString ProjectGroupName);
    __fastcall TOTAProjectGroupCreator(const AnsiString AgroupFileName);
};
#endif
